<?php

namespace IPS\brilliantdiscord\setup\upg_10060;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

use IPS\Data\Store;
use IPS\Db;

/**
 * 1.0.18 Upgrade Code
 */
class _Upgrade
{
	/**
	 * ...
	 *
	 * @return	bool|array 	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step1()
	{
        // Fix issues with incompatible sign in setting. We have our own setting for that.
        if (!Db::i()->checkForColumn('core_login_methods', 'login_front')) {
            return true;
        }
        Db::i()->update('core_login_methods', ['login_front' => true], ['login_classname=?', 'IPS\brilliantdiscord\LoginHandler']);
        unset(Store::i()->loginMethods);
        return TRUE;
	}
	
	// You can create as many additional methods (step2, step3, etc.) as is necessary.
	// Each step will be executed in a new HTTP request
}